<?php
include(dirname(__file__)."/../../../common.php");

header("content-type:text/html; charset=utf8");

$action = isset($_REQUEST["action"]) ? postval("action") : "";


if ($action == "apptrend") 
{
	$devid = postval('devid');
	$strstart = postval('tmstart');
	$strend = postval('tmend');
	$linkid = postval('linkid');
	$appid = postval('appid');
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');

	$longstart = strtotime($strstart);
	$longend = strtotime($strend);
	
	$cmd = LOGDPATH."/bin/logeye user_behavior apptrend devid=$devid ".
		"longstart=$longstart longend=$longend appid=$appid ".
		"linkid=$linkid errfile=$errfile";
	exec($cmd, $out, $ret);
	
	$date = $up = $down = $flow = array();
	foreach($out as $val) {
		list($appid, $end, $bpsup, $bpsdown, $bpsflow) = explode(' ', $val);
		if ($appid == "DATA" || $appid == "TAG")
			continue;

		array_push($date, date("d/H:i:s", $end));
		array_push($up, (int)$bpsup);
		array_push($down, (int)$bpsdown);
		array_push($flow, (int)$bpsflow);
	}

	$json = array("xdate"=>$date, "up"=>$up, "down"=>$down, "flow"=>$flow);
	echo json_encode($json);
}

if ($action == "usernum")
{
	//$cmd = "/bin/logeye user_behavior iplist_datamon errfile=/var/log/appweb/eff5.st filename=topip_dashboard";
	$cmd = "/usr/logd/bin/panalogeye ipnum list";
	exec($cmd, $out, $ret);
	$ds = explode('=', $out[0]);

	echo $ds[1];
}

if ($action == "app_data")
{
	$devid = postval('devid');
	$strstart = postval('tmstart');
	$strend = postval('tmend');
	$linkid = postval('linkid');
	$sort = postval('sort');
	$appid = postval("appid");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');

	$longstart = strtotime($strstart);
	$longend = strtotime($strend);

	$cmd = LOGDPATH."/bin/logeye user_behavior apptop devid=$devid";
	$cmd .= " longstart=$longstart longend=$longend page=$page limit=$limit";
	$cmd .= " sort=$sort linkid=$linkid errfile=$errfile appid=$appid show_ipnum=1";
	exec($cmd, $out, $return);

	$i = 0;
	$rows = array();
	foreach($out as $val) {
		$ds = explode(' ', trim($val));

		if ($ds[0] == "totalrecord")
			continue;

		if (json_encode($ds[2]) == false)
			array_push($xdata, iconv("gb2312", "utf-8", $ds[2]));
		else
			array_push($xdata, $ds[2]);
	
		$rows[$i]['apid'] = $ds[0];
		$rows[$i]['name'] = $ds[1];

		if (json_encode($ds[2]) == false)
			$rows[$i]['cname'] = iconv("gb2312", "utf-8", $ds[2]);
		else
			$rows[$i]['cname'] = $ds[2];

		$rows[$i]['flowcont'] =  (int)$ds[3];
		$rows[$i]['totalup'] = (double)$ds[4];
		$rows[$i]['totaldown'] = (double)$ds[5];
		$rows[$i]['bpsup'] = (double)$ds[6];
		$rows[$i]['bpsdown'] = (double)$ds[7];
		$rows[$i]['bpstotal'] = (double)$ds[7] + (double)$ds[6];
		$rows[$i]['linkid'] = $linkid;
		$i++;
	}

	echo json_encode($rows);
}

if ($action == "yys_data")
{
	$devid = postval("devid");
	$strstart = postval('tmstart');
	$strend = postval('tmend');
	$appid = postval('appid');
	$sort = postval("sort");
	$errfile = _CHECKING_STATUS_F.'/'.postval('errname');

	$longstart = strtotime($strstart);
	$longend = strtotime($strend);
	
	$xdata = array();
	$ydata = array();
	
	$cmd = LOGDPATH."/bin/logeye flowdir_ext session_app_top devid=$devid longstart=$longstart longend=$longend appid=$appid sort=$sort errfile=$errfile";
	exec($cmd, $out, $ret);
	foreach($out as $val) {
		$ds = explode(' ', $val);
		if ($ds[0] == "yys") {
			array_push($xdata, iconv("gb2312", "utf-8", $ds[2]));
			array_push($ydata, (float)$ds[3]+(float)$ds[4]);
		}
	}
	
	$json['x'] = $xdata;
	$json['y'] = $ydata;
	echo json_encode($json);
}

if ($action == "appgroup_flow")
{
	$devid = postval('devid');
	$strstart = postval('tmstart');
	$strend = postval('tmend');
	$linkid = postval('linkid');	/* default -1 */
	$sort = postval('sort');
	$appid = postval('appid');	/* default -1 */
	$errname = postval('errname');
	$errfile = _CHECKING_STATUS_F.'/'.$errname;

	if ($devid == "") {
		outputres("no", "devid is null");
		exit;
	}

	if (empty($strstart)) {
		outputres("no", "tmstart is null");
		exit;
	}
	if (empty($strend)) {
		outputres("no", "tmend is null");
		exit;
	}
	if (empty($linkid))
		$linkid = -1;
	if (empty($appid))
		$appid = -1;

	$longstart = strtotime($strstart);
	$longend = strtotime($strend);

	$cmd = LOGDPATH."/bin/logeye user_behavior appgroup_stat devid=$devid appid=$appid longstart=$longstart longend=$longend sort=$sort linkid=$linkid errfile=$errfile";
	exec($cmd, $output, $return);

	$rows = array();
	foreach($output as $val) {
		$ds = explode(' ', $val);
		$cname = iconv("gb2312", "utf-8", $ds[2]);
		array_push($rows, array(
			"apid"=>$ds[0],
			"name"=>$ds[1],
			"cname"=>$cname,
			"up"=>(double)$ds[3],
			"down"=>(double)$ds[4],
			"flow"=>(double)$ds[5],
		));
	}

	echo json_encode($rows);
}
?>
